//
// Copyright 2003 Sony Corporation 
//
// Permission to use, copy, modify, and redistribute this software for
// non-commercial use is hereby granted.
//
// This software is provided "as is" without warranty of any kind,
// either expressed or implied, including but not limited to the
// implied warranties of fitness for a particular purpose.
//

#ifndef JPEGEncoder_h_DEFINED
#define JPEGEncoder_h_DEFINED

#include <list>
using std::list;
#include <OPENR/ODataFormats.h>
#include <ant.h>

class JPEGEncoder {
	public:
		JPEGEncoder();
		~JPEGEncoder() {}

		bool Init(const antStackRef& ipstack);
		bool GetJPEG(OFbkImageVectorData* imageVec,
				OFbkImageLayer layer, int quality, byte** jpeg, int* size);
		bool GetJPEG(byte *yImage, int quality, byte** jpeg, int* size);
		void FreeJPEG(byte* jpeg);

		// for libjpeg test
		void Save(OFbkImageVectorData* imageVec,
				OFbkImageLayer layer, int quality, char* path);

	private:
		byte* Allocate();
		void  Free(byte* buf);

		static const int NUM_JPEG_BUF  = 4;
		static const int JPEG_BUFSIZE  = 16*1024;
		static const int IMAGE_BUFSIZE = 3*176*144; /* width 176 height 144 */

		antStackRef     ipstackRef;

		byte*           pixelInterleavedYCbCr;
		antSharedBuffer jpegBuf[NUM_JPEG_BUF];
		list<byte*>     freeJpegBufList;
};

#endif // JPEGEncoder_h_DEFINED
