#ifndef BMPRW_H_
#define BMPRW_H_

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#define IMAGE_WIDTH 176
#define IMAGE_HEIGHT 144
#define NUM_PIXELS (IMAGE_WIDTH * IMAGE_HEIGHT)

#define BMP_OFFSET_WIDTH 18
#define BMP_OFFSET_HEIGHT 22
#define BMP_OFFSET_BPP 28
#define BMP_OFFSET_COMPRESSION 30
#define BMP_OFFSET_NUMCOLOURS 46
#define BMP_HEADERSIZE 54             // BMP headers are 54 bytes
#define BMP_NUMCOLOURS 256
#define BMP_NUMBPP 8

class BMPRW
{
	private:
		char *sourcename;
		char *destinationname;
		FILE *sourcefile;
		FILE *destinationfile;
		char header[BMP_HEADERSIZE];
		char palette[BMP_NUMCOLOURS*4];
		unsigned char *image;
		size_t returnval;

		bool ReadHeader();
		bool CheckHeader();
		bool ReadPalette();
		bool ReadImageData();
		void CloseSourceFile();
		bool WriteHeader();
		bool WritePalette();
		bool WriteImageData();
		void CloseDestFile();

	public:
		BMPRW();
		BMPRW(char *sName,char *dName);
		~BMPRW();
		bool Read();           // Reads bmp-file and analyzes header
		bool Write();          // Writes bmp-file
		unsigned char* GetImageData();  // Returns a pointer to where the image data is stored
		void SetImageData(unsigned char *data);
};

#endif // BMPRW_H_
