#ifndef Constants_H
#define Constants_H

#include <math.h>

//Useful Defines
#define MAX(a,b)   (((a) > (b)) ? (a) : (b))
#define MIN(a,b)   (((a) < (b)) ? (a) : (b))

//Image
#define ORIG_IMAGE_WIDTH   176
#define ORIG_IMAGE_HEIGHT  144
#define SOBEL_IMAGE_WIDTH  175
#define SOBEL_IMAGE_HEIGHT 143
const int ORIG_IMAGE_SIZE  = ORIG_IMAGE_WIDTH * ORIG_IMAGE_HEIGHT;
const int SOBEL_IMAGE_SIZE = SOBEL_IMAGE_WIDTH * SOBEL_IMAGE_HEIGHT;
#define Y_INDEX 0
#define X_INDEX 1

//Histogram
#define NUMBER_OF_GREYS  256
#define K_MIN            -0.2
#define K_MAX            0.02 //not currently used
#define INTERVAL         5 //5
#define SMOOTH_INTERVAL  5 //6

//Blob information
#define MAX_DISTANCE_TO_PIXEL  30 //30 is the lower limit
#define ON_PIXEL        255
#define OFF_PIXEL       0
#define BLOB_PIXEL      128
#define MAX_BLOB_RADIUS 20 //20 is the lower limit
#define MIN_BLOB_SIZE   6
const int MAX_BLOB_SIZE = (int)(pow((double)MAX_BLOB_RADIUS,(double)2)*M_PI);
#define MAX_NUMBER_OF_BLOBS 20

//Ball recognition
#define DISTANCE_TOLERANCE  3
#define ANGLE_TOLERANCE  10
#define OPTIMAL_ANGLE  60
const float MIN_ANGLE = cos((double)(OPTIMAL_ANGLE - ANGLE_TOLERANCE)*(M_PI/180.0));
const float MAX_ANGLE = cos((double)(OPTIMAL_ANGLE + ANGLE_TOLERANCE)*(M_PI/180.0));
#define SCALE_TO_REAL_WORLD  10/100.0 // Needs testing

#endif
