#include <stdio.h>
#include "AdHocList.h"

AdHocList::AdHocList(void)
{
    first = NULL;
    last = NULL;
    size = 0;
}

AdHocList::~AdHocList(void)
{
    while(first != NULL){
        node_t *tmp = first->next;
        delete first;
        first = tmp;
    }
}

    void
AdHocList::Push(int data)
{
    node_t *newNode = new node_t;
    newNode->data = data;
    newNode->next = NULL;
    if(IsEmpty()){
        first = newNode;
        last = newNode;
    }
    else{
        last->next = newNode;
        last = newNode;
    }
    size++;
}

    int 
AdHocList::Pop()
{
    if(IsEmpty()){
        printf("Error: AdHocList:: Tried to pop an empty list!");
        return -10000;
    }
    int data = first->data;
    
    if(first == last){
        delete first;
        first = NULL;
        last = NULL;
    }
    else{
        node_t *tmp = first->next;
        delete first;
        first = tmp;
    }
    size--;
    return data;
}

    int 
AdHocList::IsEmpty()
{
    if(first == NULL)
        return 1;
    return 0;
}

    void
AdHocList::Print()
{
    node_t *tmp = first;
    printf("\nPRINTING LIST\n");
    while(tmp != NULL){
        printf("%d ", tmp->data);
        tmp = tmp->next;
    }
    printf("\n\n");
}

    int
AdHocList::Size()
{
    return size;
}

    void 
AdHocList::Append(AdHocList *data)
{
    for(int i=0; i<data->Size(); i++)
        Push(data->Get(i));
}

    int
AdHocList::Get(int index)
{
    if(index >= size){
        printf("\nError: AdHocList:: Tried to Get index that don't exist\n");
        return -10000;
    }
    node_t *tmp = first;
    for(int i=0; i<index; i++)
        tmp = tmp->next;
    return tmp->data;
}

    int 
AdHocList::IsElement(int elem)
{
    node_t *tmp = first;
    while(tmp != NULL)
        if(tmp->data == elem)
            return 1;
        else
            tmp = tmp->next;
    return 0;
}

    int
AdHocList::Max()
{
    node_t *tmp = first;
    int Maxval = -1000000;

    while(tmp != NULL){
        if(tmp->data > Maxval)
            Maxval = tmp->data;
        tmp = tmp->next;
    }

    return Maxval;
}

    int
AdHocList::Min()
{
    node_t *tmp = first;
    int Minval = 1000000;

    while(tmp != NULL){
        if(tmp->data < Minval)
            Minval = tmp->data;
        tmp = tmp->next;
    }

    return Minval;
}

    int*
AdHocList::ToArray(int array[])
{
    int cntr=0;
    node_t *tmp = first;
    while(tmp != NULL){
        array[cntr]=tmp->data;
        tmp = tmp->next;
        cntr++;
    }
    return array;
}

