#Masks
mask_h = [[ 0, 1],
          [-1, 0]]
mask_v = [[ 1, 0],
          [ 0,-1]]


def horizontalFlood(offset, image):
    """Fill left and right"""
    image[offset] = ON_PIXEL
    x = offset % SOBEL_IMAGE_WIDTH
    index = offset - 1
    while x-(offset-index) >= 0 and image[index] == OFF_PIXEL:
        verticalFlood(index, image)
        image[index] = ON_PIXEL
        index -= 1
    index = offset + 1
    while x+(index-offset) < SOBEL_IMAGE_WIDTH and image[index] == OFF_PIXEL:
        verticalFlood(index, image)
        image[index] = ON_PIXEL
        index += 1
         
def verticalFlood(offset, image):
    """Fill up and down"""
    #image[offset] = ON_PIXEL
    horizontalFlood(offset, image)
    index = offset-SOBEL_IMAGE_WIDTH
    while index >= 0 and image[index] == OFF_PIXEL:
        horizontalFlood(index, image)
        image[index] = ON_PIXEL
        index -= SOBEL_IMAGE_WIDTH
    index = offset+SOBEL_IMAGE_WIDTH
    max = SOBEL_IMAGE_WIDTH*SOBEL_IMAGE_HEIGHT
    while index < max and image[index] == OFF_PIXEL:
        horizontalFlood(index, image)
        image[index] = ON_PIXEL
        index += SOBEL_IMAGE_WIDTH

    
def badFloodFill(offset, image):
    """Fills the area starting at offset"""
    verticalFlood(offset, image)

def sum(matrix):
    """Summarize the values in the matrix"""
    result = 0;
    for i in range(len(matrix)):
        for j in range(len(matrix[0])):
            result += matrix[i][j];
    if result < 1:
        return 1
    else:
        return result

def convIt(x, y, image, mask_h, mask_v):
    """Apply a mask to an image and return the resulting pixel"""
    result_h = 0
    result_v = 0
    
    for i in range(len(mask_h)):
        for j in range(len(mask_h[0])):
            index = (y+i)*ORIG_IMAGE_WIDTH+(x+j)
            result_h += mask_h[i][j]*image[index]
            result_v += mask_v[i][j]*image[index]

    result_h = result_h / sum(mask_h)
    result_v = result_v / sum(mask_v)
    return pow(pow(result_h,2) + pow(result_v,2), 0.5)

def convolutionMask(oldIm, oldImSize, mask_h, mask_v):
    """Apply a mask to an image and return the resulting image"""
    newIm = []
    xlen,ylen = oldImSize
    yrange = range(ylen-(len(mask_h)-1))
    xrange = range(xlen-(len(mask_h[0])-1))
    for y in yrange:
        for x in xrange:
            newIm += [min(convIt(x,y,oldIm,mask_h,mask_v),ON_PIXEL)]
    return newIm
